# Generated by Django 4.1.4 on 2023-01-04 06:15

import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models

import seawatch_registration.models


def create_SarApplications_from_PositionDecisions(apps, schema_editor):
    PositionDecision = apps.get_model("applications", "PositionDecision")
    SarApplication = apps.get_model("applications", "SarApplication")

    SarApplication.objects.bulk_create(
        [
            SarApplication(
                application=pd.application, position=pd.position, decision=pd.decision
            )
            for pd in PositionDecision.objects.all()
        ]
    )


def create_PositionDecisions_from_SarApplications(apps, schema_editor):
    PositionDecision = apps.get_model("applications", "PositionDecision")
    SarApplication = apps.get_model("applications", "SarApplication")

    PositionDecision.objects.bulk_create(
        [
            PositionDecision(
                application=sa.application, position=sa.position, decision=sa.decision
            )
            for sa in SarApplication.objects.all()
        ]
    )


class Migration(migrations.Migration):
    dependencies = [
        ("seawatch_registration", "0036_alter_userprofile_user"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ("applications", "0041_delete_malformedapplication"),
    ]

    operations = [
        migrations.CreateModel(
            name="SarApplication",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "decision",
                    seawatch_registration.models.ShortTextField(
                        choices=[
                            ("open", "Open"),
                            ("reject", "Reject"),
                            ("accept", "Accept"),
                        ],
                        default="open",
                    ),
                ),
                ("time", models.DateTimeField(default=None, null=True)),
                (
                    "application",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="applications.application",
                    ),
                ),
                (
                    "by",
                    models.ForeignKey(
                        default=None,
                        null=True,
                        on_delete=django.db.models.deletion.PROTECT,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "position",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.PROTECT,
                        to="seawatch_registration.position",
                    ),
                ),
            ],
        ),
        migrations.AddConstraint(
            model_name="sarapplication",
            constraint=models.UniqueConstraint(
                fields=("position", "application"),
                name="sarapplication__position_application__unique",
            ),
        ),
        migrations.RunPython(
            create_SarApplications_from_PositionDecisions,
            create_PositionDecisions_from_SarApplications,
        ),
        migrations.DeleteModel(
            name="PositionDecision",
        ),
        migrations.AlterField(
            model_name="application",
            name="positions",
            field=models.ManyToManyField(
                through="applications.SarApplication",
                to="seawatch_registration.position",
            ),
        ),
    ]
